/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
//#define _DEBUG

#define ARRAY_SIZE(X) 		sizeof(X)/sizeof(uint)
#define LESS(x,y)  			(x < y)
#define SWAP(x,y)  			{int t=x; x=y; y=t;}

/// @todo digital keys checking in input fields
/// @todo use QMemArray for nScales??
static uint nScales[100]; // main scales array

// string array for length types
static const char *szTypes[] = {"mm", "cm", "dm", "m", "km", "inch", "foot", "yard"};

// array for metric -> length_unit conversions
static float fMultiples[] = {0.001, 0.01, 0.1, 1, 1000, 0.0254, 0.3048, 0.9144000003};

static const char *szScaleNames[] = {"All/Default", "Aviation", "Figures", "Armour", "Ships","Autos", "Railroad", "Space"};
/// @todo This language don´t support not balanced array!!!!
static uint nScaleSets[][15]= {{1,12,24,32,35,48,64,72,96,100,125,144,200}, //Aviation
{1,6,7,8,10,12,14,16,32,35,48,72,87,100},
{1,16,25,35,48,72,76,27,285}, // Armor
{1,72,96,100,192,200,350,700,720,1200,2400}, // Ship
{1,8,12,16,18,20,24,25,32,43}, // Auto
{1,48,64,87,160,220}, // Railroad
{1,24,72,144,1000,2500,7000,12000} // Space
};


static bool in_array(uint *ar, uint nSize, uint mem);
static void array_sort(uint a[] , uint n);
static uint get_scale_offset();


void PocketScaleRHWidgetBase::init()
{
	uint i;
	QString qs;
	
	for(i=0; i<sizeof(szScaleNames)/sizeof(const char*) ; i++)
	{
		qs = QString(szScaleNames[i]);
		this->cmbTypeOfScales->insertItem(  qs );
	}

	this->changeTypeOfScale();

	// Add metrics types to ComboBoxes
	for(i=0; i<sizeof(szTypes)/sizeof(const char *); i++)
	{
		qs.setAscii(szTypes[i]);
		this->inType->insertItem(  qs );
		this->outType->insertItem( qs  );
		this->inType2->insertItem(  qs );
		this->outType2->insertItem( qs  );
	}
	
}

void PocketScaleRHWidgetBase::calculateValue() 
{
 	uint 
		nOffset = get_scale_offset(),
		nInType = this->inType->currentItem(),
 		nOutType = this->outType->currentItem(),
		nInScale = nScales[ nOffset+this->inScale->currentItem() ], 
		nOutScale = nScales[ nOffset+this->outScale->currentItem() ];
	float 
		fInMultiple = fMultiples[nInType], 
		fOutMultiple = fMultiples[nOutType],
		fInValue = this->inValue->text().toFloat(),
		fResult;
		
	QString 
		qsText;
	
	fResult = fInValue  * nInScale / nOutScale / fOutMultiple * fInMultiple;
	qsText.setNum(fResult);
	this->outValue->setText( qsText );

#ifdef _DEBUG
	qsText = QString("Input: %1%2 Scale=1/%3 Multiple %4 \n Scale=1/%5 Multiple = %6 \n Result= %7 %8 ") 
									.arg(fInValue) .arg(szTypes[nInType]) .arg(nInScale) .arg(fInMultiple)
									.arg(nOutScale) .arg(fOutMultiple)
									.arg (fResult) .arg(szTypes[nOutType]);

	lblResult->setText(qsText);
#endif
}

void PocketScaleRHWidgetBase::calculateScale() 
{
 	int 
		nInType = this->inType2->currentItem(),
 		nOutType = this->outType2->currentItem();
	double
		fInMultiple = fMultiples[nInType], 
		fOutMultiple = fMultiples[nOutType],
		fInValue = this->inValue2->text().toFloat(),
		fOutValue = this->outValue2->text().toFloat(),
		fResult;
	QString qsText;
	
	fResult = (fInValue / fInMultiple) / (fOutValue / fOutMultiple);
/// @todo output scale that lesser 1
 	if(fResult > 1)
	qsText = QString ("Scale is 1/%1") .arg(fResult, 10);
 	else
 	qsText = QString ("Scale is %1") .arg(fResult, 10);
	
	this->outScale2->setText( qsText );
#ifdef _DEBUG
	qsText = QString("Input: %1%2 Multiple %3 \n Output:%4%5  Multiple = %6 \n Result=1/%7 ") 
									.arg(fInValue) .arg(szTypes[nInType]) .arg(fInMultiple)
									.arg(fOutValue) .arg(szTypes[nOutType]) .arg(fOutMultiple)
									.arg (fResult);

	lblResult->setText(qsText);
#endif
}


void PocketScaleRHWidgetBase::changeTypeOfScale()
{
	uint 
		nType = this->cmbTypeOfScales->currentItem(),
		nIndx = 0,
		j;
	
	for(j = 0; j<ARRAY_SIZE(nScales) ; j++) // clean nScales array
		nScales[j] = 0;
	
	if(nType > 0)
	{
		nType--; // reduce index - All/Default not stored in nScaleSets
		for(j=0; j<ARRAY_SIZE(nScaleSets[nType]) ; j++ )
		{
			// if not found in array store scale value
			if( nScaleSets[nType][j] > 0  && !in_array(nScales, ARRAY_SIZE(nScales), nScaleSets[nType][j]) )
				nScales[nIndx++] = nScaleSets[nType][j];
			
		}
	}
	else // get all sets of scales
	{
		uint  
			n = sizeof(szScaleNames)/sizeof(const char *) - 1; // note -1 - All/Default set not store!!!
		
		for(uint i=0; i<n; i++) 
		{
			for(j=0; j<ARRAY_SIZE(nScaleSets[i]) ; j++ )
			{
				// if not found in array store scale value
				if( nScaleSets[i][j]>0 && !in_array(nScales, ARRAY_SIZE(nScales), nScaleSets[i][j]) )
					nScales[nIndx++] = nScaleSets[i][j];
				
			}
		}
	}
	this->setTypeOfScale();
}


void PocketScaleRHWidgetBase::setTypeOfScale()
{
	uint 
		nSize = ARRAY_SIZE(nScales);
	QString 
		qs1, 
		qs;
	
	// clean scale comboboxes
	while(this->inScale->count()) 
		this->inScale->removeItem(0);
	
	while(this->outScale->count())
		this->outScale->removeItem(0);
	
	array_sort(nScales, nSize);
	
	for(uint i=0; i<nSize ; i++)
	{
		if( nScales[i] > 0 )
		{
			qs1.setNum(nScales[i]);
			qs = QString("1/%1")	.arg (qs1);
			this->inScale->insertItem(  qs );
			this->outScale->insertItem( qs );
		}
	}
	
	this->inScale->setCurrentItem(0);
	this->outScale->setCurrentItem(0);
}



// is the element presents in array
static bool in_array(uint *ar, uint nSize, uint mem)
{
	for(uint i=0; i<nSize; i++)
	{
		if(ar[i] == mem)
		return TRUE;
	}
	return FALSE;
}

// array sorting - at this moment - slow bubble sorting
static void array_sort(uint a[] , uint n) /// @todo more quick sorting
{
	for ( uint i=0; i<n; i++ )
	{
		for (uint j=n-1; j>i; j--)
		{
			if (LESS(a[j], a[j-1]))
				SWAP(a[j], a[j-1]);	
		}
	}
}

// scrolling for non-zero values in arry of scale
static uint get_scale_offset() 
{
	uint i;
	for( i=0; i<ARRAY_SIZE(nScales); i++ )
	{
		if( nScales[i] > 0 )
		{
			return i;
		}
	}
	return 0;
}